

#ifndef _KERNEL64API_H_
#define _KERNEL64API_H_

#include "Wow64Api.h"


//VirtualQueryEx64///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
SIZE_T WINAPI VirtualQueryEx64(HANDLE hProcess, LP64CVOID lpAddress, PMEMORY_BASIC_INFORMATION64_ lpBuffer, SIZE_T dwLength) {
#ifndef _NTOPT
  if(g_pZwWow64QueryVirtualMemory64) {
#endif
    SIZE64_T dwLength64;
    NTSTATUS Status = g_pZwWow64QueryVirtualMemory64(hProcess, lpAddress, 0, lpBuffer, dwLength, &dwLength64);
    if(Status < 0) {
#ifndef _NTOPT
      SetLastError(g_pRtlNtStatusToDosError != NULL ? g_pRtlNtStatusToDosError(Status) : ERROR_INVALID_PARAMETER);
#else
      SetLastError(g_pRtlNtStatusToDosError(Status));
#endif
      return(0);
    }
    else {
      return((SIZE_T)dwLength64);
    }
#ifndef _NTOPT
  }
  else {
    if(((ULONGLONG)lpAddress >> 32) || (dwLength != sizeof(MEMORY_BASIC_INFORMATION64_))) {
      SetLastError(ERROR_INVALID_PARAMETER);
      return(0);
    }
    else {
      MEMORY_BASIC_INFORMATION mbi;
      SIZE_T dwLength32 = VirtualQueryEx(hProcess, Ptr64ToPtr(lpAddress), &mbi, sizeof(mbi));
      if(dwLength32 == sizeof(mbi)) {
        lpBuffer->BaseAddress = (LP64VOID)mbi.BaseAddress;
        lpBuffer->AllocationBase = (LP64VOID)mbi.AllocationBase;
        lpBuffer->AllocationProtect = mbi.AllocationProtect;
        lpBuffer->RegionSize = mbi.RegionSize;
        lpBuffer->State = mbi.State;
        lpBuffer->Protect = mbi.Protect;
        lpBuffer->Type = mbi.Type;
      }
      return(dwLength32);
    }
  }
#endif
}

//ReadProcessMemory64/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL WINAPI ReadProcessMemory64(HANDLE hProcess, LP64CVOID lpBaseAddress, LPVOID lpBuffer, SIZE_T nSize, SIZE_T* lpNumberOfBytesRead) {
#ifndef _NTOPT
  if(g_pZwWow64ReadVirtualMemory64) {
#endif
    SIZE64_T NumberOfBytesRead;
    NTSTATUS Status = g_pZwWow64ReadVirtualMemory64(hProcess, lpBaseAddress, lpBuffer, nSize, &NumberOfBytesRead);
    if(Status < 0) {
#ifndef _NTOPT
      SetLastError(g_pRtlNtStatusToDosError != NULL ? g_pRtlNtStatusToDosError(Status) : ERROR_INVALID_PARAMETER);
#else
      SetLastError(g_pRtlNtStatusToDosError(Status));
#endif
      return(FALSE);
    }
    else {
      if(lpNumberOfBytesRead) {
        *lpNumberOfBytesRead = (SIZE_T)NumberOfBytesRead;
      }
      return(TRUE);
    }
#ifndef _NTOPT
  }
  else {
    if((ULONGLONG)lpBaseAddress >> 32) {
      SetLastError(ERROR_INVALID_PARAMETER);
      return(FALSE);
    }
    else {
      return(ReadProcessMemory(hProcess, Ptr64ToPtr(lpBaseAddress), lpBuffer, nSize, lpNumberOfBytesRead));
    }
  }
#endif
}

//WriteProcessMemory64////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL WINAPI WriteProcessMemory64(HANDLE hProcess, LP64VOID lpBaseAddress, LPCVOID lpBuffer, SIZE_T nSize, SIZE_T* lpNumberOfBytesWritten) {
#if !defined(_NTOPT) || (_WIN32_WINNT <= 0x0502)
  if(g_pZwWow64WriteVirtualMemory64) {
#endif
    SIZE64_T NumberOfBytesWritten;
    NTSTATUS Status = g_pZwWow64WriteVirtualMemory64(hProcess, lpBaseAddress, lpBuffer, nSize, &NumberOfBytesWritten);
    if(Status < 0) {
#ifndef _NTOPT
      SetLastError(g_pRtlNtStatusToDosError != NULL ? g_pRtlNtStatusToDosError(Status) : ERROR_INVALID_PARAMETER);
#else
      SetLastError(g_pRtlNtStatusToDosError(Status));
#endif
      return(FALSE);
    }
    else {
      if(lpNumberOfBytesWritten) {
        *lpNumberOfBytesWritten = (SIZE_T)NumberOfBytesWritten;
      }
      return(TRUE);
    }
#if !defined(_NTOPT) || (_WIN32_WINNT <= 0x0502)
  }
  else {
    if((ULONGLONG)lpBaseAddress >> 32) {
      SetLastError(ERROR_INVALID_PARAMETER);
      return(FALSE);
    }
    else {
      return(WriteProcessMemory(hProcess, Ptr64ToPtr(lpBaseAddress), lpBuffer, nSize, lpNumberOfBytesWritten));
    }
  }
#endif
}

#endif
