

#ifndef _WOW64API_H_
#define _WOW64API_H_


typedef LONG NTSTATUS;
typedef void * __ptr64 LP64VOID;
typedef const void * __ptr64 LP64CVOID;
typedef ULONGLONG SIZE64_T;



//ZwWow64GetNativeSystemInformation////////////////////////////////////////////////////////////
//class 0+1 used by GetNativeSystemInfo()
//difference in MaximumUserModeAddress and ProcessorArchitecture fields
//class 62 == crippled class 0 
//class 63 == crippled class 1


//ZwWow64QueryInformationProcess64/////////////////////////////////////////////////////////////
//class 0
typedef struct __declspec(align(16)) _PROCESS_BASIC_INFORMATION64_ {
  NTSTATUS ExitStatus;
  DWORD align1;
  LP64VOID PebBaseAddress;
  ULONGLONG AffinityMask;
  LONG BasePriority;
  DWORD align2;
  ULONGLONG UniqueProcessId;
  ULONGLONG InheritedFromUniqueProcessId;
} PROCESS_BASIC_INFORMATION64_, *PPROCESS_BASIC_INFORMATION64_, *LPPROCESS_BASIC_INFORMATION64_;


//ZwWow64QueryVirtualMemory64//////////////////////////////////////////////////////////////////
//class 0
typedef struct __declspec(align(16)) _MEMORY_BASIC_INFORMATION64_ {
  LP64VOID BaseAddress;
  LP64VOID AllocationBase;
  DWORD AllocationProtect;
  DWORD align1;
  SIZE64_T RegionSize;
  DWORD State;
  DWORD Protect;
  DWORD Type;
  DWORD align2;
} MEMORY_BASIC_INFORMATION64_, *PMEMORY_BASIC_INFORMATION64_, *LPMEMORY_BASIC_INFORMATION64_;


//ZwWow64CallFunction64////////////////////////////////////////////////////////////////////////
#define WOW64_CF64_NOP
#define WOW64_CF64_QUERYPROCDEBUGINFO


#ifdef _NTOPT

#pragma comment(lib, "ntdll.lib")
#ifdef __cplusplus
extern "C" {
#endif
#ifdef _MSC_VER
#define _DLLIMPORT __declspec(dllimport)
#else
#define _DLLIMPORT
#endif
#define _NTAPIPROTO _DLLIMPORT NTSTATUS WINAPI 
_DLLIMPORT ULONG WINAPI RtlNtStatusToDosError(NTSTATUS);
_NTAPIPROTO ZwWow64GetNativeSystemInformation(ULONG, PVOID, ULONG, PULONG);
_NTAPIPROTO ZwWow64QueryInformationProcess64(HANDLE, ULONG, PPROCESS_BASIC_INFORMATION64_, ULONG, PULONG);
_NTAPIPROTO ZwWow64QueryVirtualMemory64(HANDLE, LP64CVOID, ULONG, PMEMORY_BASIC_INFORMATION64_, SIZE64_T, SIZE64_T*);
_NTAPIPROTO ZwWow64ReadVirtualMemory64(HANDLE, LP64CVOID, LPVOID, SIZE64_T, SIZE64_T*);
#if _WIN32_WINNT > 0x0502
_NTAPIPROTO ZwWow64WriteVirtualMemory64(HANDLE, LP64VOID, LPCVOID, SIZE64_T, SIZE64_T*);
_NTAPIPROTO ZwWow64CallFunction64(ULONG, ULONG, ULONG, LPVOID, ULONG, LPVOID, PULONG);
#endif
#undef _NTAPIPROTO
#ifdef __cplusplus
}
#endif
#define g_pRtlNtStatusToDosError RtlNtStatusToDosError
#define g_pZwWow64GetNativeSystemInformation ZwWow64GetNativeSystemInformation
#define g_pZwWow64QueryInformationProcess64 ZwWow64QueryInformationProcess64
#define g_pZwWow64QueryVirtualMemory64 ZwWow64QueryVirtualMemory64
#define g_pZwWow64ReadVirtualMemory64 ZwWow64ReadVirtualMemory64
#if _WIN32_WINNT > 0x0502
#define g_pZwWow64WriteVirtualMemory64 ZwWow64WriteVirtualMemory64
#define g_pZwWow64CallFunction64 ZwWow64CallFunction64
#define GetWow64Api() (NULL)
#else
typedef NTSTATUS (WINAPI *TZwWow64WriteVirtualMemory64)(HANDLE, LP64VOID, LPCVOID, SIZE64_T, SIZE64_T*);
typedef NTSTATUS (WINAPI *TZwWow64CallFunction64)(ULONG, ULONG, ULONG, LPVOID, ULONG, LPVOID, PULONG);
TZwWow64WriteVirtualMemory64 g_pZwWow64WriteVirtualMemory64 = NULL;
TZwWow64CallFunction64 g_pZwWow64CallFunction64 = NULL;
HMODULE WINAPI GetWow64Api(VOID) {
  HMODULE hNTDLL = GetModuleHandleW(L"NTDLL.DLL");
  if(hNTDLL) {
    g_pZwWow64WriteVirtualMemory64 = (TZwWow64WriteVirtualMemory64)GetProcAddress(hNTDLL, "ZwWow64WriteVirtualMemory64");
    g_pZwWow64CallFunction64 = (TZwWow64CallFunction64)GetProcAddress(hNTDLL, "ZwWow64CallFunction64");
  }
  g_bWow64ApiInited = TRUE;
  return(hNTDLL);
}
#endif

#else

typedef ULONG (WINAPI *TRtlNtStatusToDosError)(NTSTATUS);
typedef NTSTATUS (WINAPI *TZwWow64GetNativeSystemInformation)(ULONG, PVOID, ULONG, PULONG);
typedef NTSTATUS (WINAPI *TZwWow64QueryInformationProcess64)(HANDLE, ULONG, PPROCESS_BASIC_INFORMATION64_, ULONG, PULONG);
typedef NTSTATUS (WINAPI *TZwWow64QueryVirtualMemory64)(HANDLE, LP64CVOID, ULONG, PMEMORY_BASIC_INFORMATION64_, SIZE64_T, SIZE64_T*);
typedef NTSTATUS (WINAPI *TZwWow64ReadVirtualMemory64)(HANDLE, LP64CVOID, LPVOID, SIZE64_T, SIZE64_T*);
typedef NTSTATUS (WINAPI *TZwWow64WriteVirtualMemory64)(HANDLE, LP64VOID, LPCVOID, SIZE64_T, SIZE64_T*);
typedef NTSTATUS (WINAPI *TZwWow64CallFunction64)(ULONG, ULONG, ULONG, LPVOID, ULONG, LPVOID, PULONG);
TRtlNtStatusToDosError g_pRtlNtStatusToDosError = NULL;
TZwWow64GetNativeSystemInformation g_pZwWow64GetNativeSystemInformation = NULL;
TZwWow64QueryInformationProcess64 g_pZwWow64QueryInformationProcess64 = NULL;
TZwWow64QueryVirtualMemory64 g_pZwWow64QueryVirtualMemory64 = NULL;
TZwWow64ReadVirtualMemory64 g_pZwWow64ReadVirtualMemory64 = NULL;
TZwWow64WriteVirtualMemory64 g_pZwWow64WriteVirtualMemory64 = NULL;
TZwWow64CallFunction64 g_pZwWow64CallFunction64 = NULL;
HMODULE WINAPI GetWow64Api(VOID) {
  HMODULE hNTDLL = GetModuleHandleW(L"NTDLL.DLL");
  if(hNTDLL) {
    g_pRtlNtStatusToDosError = (TRtlNtStatusToDosError)GetProcAddress(hNTDLL, "RtlNtStatusToDosError");
    g_pZwWow64GetNativeSystemInformation = (TZwWow64GetNativeSystemInformation)GetProcAddress(hNTDLL, "ZwWow64GetNativeSystemInformation");
    g_pZwWow64QueryInformationProcess64 = (TZwWow64QueryInformationProcess64)GetProcAddress(hNTDLL, "ZwWow64QueryInformationProcess64");
    g_pZwWow64QueryVirtualMemory64 = (TZwWow64QueryVirtualMemory64)GetProcAddress(hNTDLL, "ZwWow64QueryVirtualMemory64");
    g_pZwWow64ReadVirtualMemory64 = (TZwWow64ReadVirtualMemory64)GetProcAddress(hNTDLL, "ZwWow64ReadVirtualMemory64");
    g_pZwWow64WriteVirtualMemory64 = (TZwWow64WriteVirtualMemory64)GetProcAddress(hNTDLL, "ZwWow64WriteVirtualMemory64");
    g_pZwWow64CallFunction64 = (TZwWow64CallFunction64)GetProcAddress(hNTDLL, "ZwWow64CallFunction64");
  }
  return(hNTDLL);
}

#endif

#endif
